# console.tcl --
#
# Simple commands to replace the internal "pvm" commands
#

proc help {args} {
    error "sorry, not yet implemented"
}

proc addhost {args} {
    return [eval pvm addhost $args]
}

proc delhost {args} {
    return [eval pvm delhost $args]
}

proc joingroup {groupname} {
    return [pvm joingroup $groupname]
}

proc leavegroup {groupname} {
    return [pvm leavegroup $groupname]
}

proc spawn {args} {
    return [eval pvm spawn $args]
}

proc kill {args} {
    return [eval pvm kill $args]
}

proc recv {args} {
    return [eval pvm recv $args]
}

proc ps {args} {
    error "sorry, not yet implemented"
}

proc setenv {varname args} {
    global env
    return [eval set env($varname) $args]
}

proc echo {args} {
    return [eval exec echo $args]
}

proc term {name args} {
    global tkpvm_library
    if {[catch {set tid [eval spawn $tkpvm_library/examples/term.tcl $args]}]} {
	if {[catch {set tid [eval spawn $tkpvm_library/../examples/term.tcl $args]}]} {
	    if {[catch {set tid [eval spawn $tkpvm_library/term.tcl $args]}]} {
		set tid [eval spawn term.tcl $args]
	    }
	}
    }
    if {$args!=""} {
	bind $tid 0 {eval [recv string]}
    }
    proc $name {string} "send $tid 0 \".t insert end \\\"\$string\\n\\\"\""
    return $name
}

proc dialog {args} {
    error "sorry, not yet implemented"
}

proc version {{package all}} {
    catch {set version "tcl\t[info tclversion]"}
#
# check the variables that might contain information about
# versions of included packages. These variables are expected
# to look like xxx_version, where "xxx" is the package name.
#
    foreach varname [uplevel #0 info vars *_version] {
	set pack [string range $varname 0 [expr [string first _ $varname]-1]]
	if {[lsearch $version $pack]<0} {
	    append version "\n$pack\t[uplevel #0 set $varname]"
	}
    }
    if {[set index [lsearch $version $package]]>=0} {
	return [lindex $version [expr $index^1]]
    } elseif {$package=="all"||$package==""} {
	return $version
    } else {
	error "unknown package name: \"$package\"
    }
}

proc id {} {
    return [pvm mytid]
}

proc tasks {args} {
    return [eval pvm tasks $args]
}

proc parent {args} {
    return [eval pvm parent $args]
}

proc sig {num tid} {
    error "sorry, not yet implemented"
}

proc reset {} {
    foreach tid [tasks] {
	if {$tid!=[id]} {
	    kill $tid
	}
    }
}

proc quit {} {
    exit
}

proc halt {} {
    pvm halt
}
